#!/usr/bin/perl

use Data::Dumper;

# the first and second command line arguments
my $infile=shift;
my $asm=shift;

open(IN, $infile) || die ("cant open $infile $!");
while (my $line = <IN>)	{
	if ( $line =~ /%%/ )	{
		if ( $status==0 )	{
			# reset the vars when status not equal to 1 and %% is detected
			$status=1;
			$title="";
			$address=0;
			$equ="";
			$flag=0;
			# set status to 1 to start collecting data
			$status=1;
		} else {
			# collect data from this line, populate text and flags hash by address 
			$status=0;
			if ($flag==0)	{
				if (length($title) && $address > 0x8000)	{
					#$text{$address} = sprintf "label %04X $title\n", $address;
					$text{$address} = sprintf "$title\n", $address;
				}
			}
			else {
				if ($flags{$address}!=1)	{
					#$text{$address} = sprintf "label %04X FLAGS $title\n", $address;
					$text{$address} = sprintf "FLAG $title\n", $address;
					$flags{$address}=1;
				}
			}
		}
	}
	if ($line =~ /%%FLAG/)	{
		$flag=1;
	}
	# collect anything that is not a " between the quotes
	if ($line =~ /Title\s+="([^"]*)"/)	{
		$title = $1;
		#print "title $title\n";
	} elsif ( $line =~ /Address\s+=0x(\w{1,4})$/ )	{
		$address = hex($1);
		$address += 0x8000;
		#printf "address %04x\n", $address;
	} elsif ( $line =~ /Equation\s+=(.*)$/ )	{
		chomp($1);
		$equ = $1;
		#print "equ $equ\n";
	}
}

# uncomment this to dump out the collected data to screen to see if it looks correct
#foreach my $line (sort keys(%text))	{
#	print $text{$line};
#}
#exit;

close(IN);

#print Dumper(\%text);

# open $asm to handle ASM or die with error + system error
open (ASM, $asm) || die ("Cant open asm file $asm $!\n");

while (my $line = <ASM>)	{
	foreach my $addr (keys(%text))	{
		$search = sprintf("L%04X", $addr);
		#print ("looking for $search\n");
		if ( $line =~ /$search/ )	{
			#print "got it! $line ->";
			chomp($line);
			#print "appending ".$text{$addr}."\n";
			# got some text for this address, append it to the line
			$line .= " ;".$text{$addr};
		}
	}
	# print the line to STDOUT
	print "$line";
}

close (ASM);
